Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hsqldb.jdbc
Class jdbcPreparedStatement

    java.lang.Object
      org.hsqldb.jdbc.jdbcStatement
          org.hsqldb.jdbc.jdbcPreparedStatement

All Implemented Interfaces:
  java.sql.PreparedStatement, java.sql.Statement, java.sql.Wrapper

Direct Known Subclasses:
  jdbcCallableStatement

    public class jdbcPreparedStatement

extends jdbcStatement
implements java.sql.PreparedStatement

An object that represents a precompiled SQL statement.

An SQL statement is precompiled and stored in a `PreparedStatement` object. This object can then be used to efficiently execute this statement multiple times.

Note: The setter methods (`setShort`, `setString`, and so on) for setting IN parameter values must specify types that are compatible with the defined SQL type of the input parameter. For instance, if the IN parameter has SQL type `INTEGER`, then the method `setInt` should be used.

If arbitrary parameter type conversions are required, the method `setObject` should be used with a target SQL type.

In the following example of setting a parameter, `con` represents an active connection:

     PreparedStatement pstmt = con.prepareStatement("UPDATE EMPLOYEES
                                   SET SALARY = ? WHERE ID = ?");
     pstmt.setBigDecimal(1, 153833.00)
     pstmt.setInt(2, 110592)

### HSQLDB-Specific Information:

Starting with HSQLDB 1.7.2, jdbcPreparedStatement objects are backed by a true compiled parameteric representation. Hence, there are now significant performance gains to be had by using a jdbcPreparedStatement object in preference to a jdbcStatement object, if a short-running SQL statement is to be executed more than a small number of times.

When it can be otherwise avoided, it is to be considered poor practice to fully prepare (construct), parameterize, execute, fetch and close a jdbcPreparedStatement object for each execution cycle. Indeed, under HSQLDB 1.8.0, this practice is likely to be noticably less performant for short-running statements than the equivalent process using jdbcStatement objects, albeit far more convenient, less error prone and certainly much less resource-intensive, especially when large binary and character values are involved, due to the optimized parameterization facility.

Instead, when developing an application that is not totally oriented toward the execution of ad hoc SQL, it is recommended to expend some effort toward identifing the SQL statements that are good candidates for regular reuse and adapting the structure of the application accordingly. Often, this is done by recording the text of candidate SQL statements in an application resource object (which has the nice side-benefit of isolating and hiding differences in SQL dialects across different drivers) and caching for possible reuse the PreparedStatement objects derived from the recorded text.

Multi thread use:

A PreparedStatement object is stateful and should not normally be shared by multiple threads. If it has to be shared, the calls to set the parameters, calls to add batch statements, the execute call and any post-execute calls should be made within a block synchronized on the PreparedStatement Object.

JRE 1.1.x Notes:

In general, JDBC 2 support requires Java 1.2 and above, and JDBC3 requires Java 1.4 and above. In HSQLDB, support for methods introduced in different versions of JDBC depends on the JDK version used for compiling and building HSQLDB.

Since 1.7.0, it is possible to build the product so that all JDBC 2 methods can be called while executing under the version 1.1.x Java Runtime EnvironmentTM. However, in addition to requiring explicit casts to the org.hsqldb.jdbcXXX interface implementations, some of these method calls require `int` values that are defined only in the JDBC 2 or greater version of `ResultSet` interface. For this reason, when the product is compiled under JDK 1.1.x, these values are defined in `jdbcResultSet`.

In a JRE 1.1.x environment, calling JDBC 2 methods that take or return the JDBC2-only `ResultSet` values can be achieved by referring to them in parameter specifications and return value comparisons, respectively, as follows:

     jdbcResultSet.FETCH_FORWARD
     jdbcResultSet.TYPE_FORWARD_ONLY
     jdbcResultSet.TYPE_SCROLL_INSENSITIVE
     jdbcResultSet.CONCUR_READ_ONLY
     // etc.

However, please note that code written in such a manner will not be compatible for use with other JDBC 2 drivers, since they expect and use `ResultSet`, rather than `jdbcResultSet`. Also note, this feature is offered solely as a convenience to developers who must work under JDK 1.1.x due to operating constraints, yet wish to use some of the more advanced features available under the JDBC 2 specification.

(fredt@users)
(boucherb@users)

Author:
  boucherb@users, fredt@users
See Also:
  `jdbcConnection.prepareStatement(java.lang.String)`, `jdbcResultSet`

Field Summary

Fields inherited from interface java.sql.Statement
`CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

Method Summary
`void` | `addBatch()` Adds a set of parameters to this `PreparedStatement` object's batch of commands.
`void` | `addBatch(java.lang.String sql)` This method should always throw if called for a PreparedStatement or CallableStatment.
`void` | `clearParameters()` Clears the current parameter values immediately.
`void` | `close()` Does the specialized work required to free this object's resources and that of it's parent class.
`boolean` | `execute()` Executes the SQL statement in this `PreparedStatement` object, which may be any kind of SQL statement.
`boolean` | `execute(java.lang.String sql)` This method should always throw if called for a PreparedStatement or CallableStatment.
`int[]` | `executeBatch()` Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts.
`java.sql.ResultSet` | `executeQuery()` Executes the SQL query in this `PreparedStatement` object and returns the `ResultSet` object generated by the query.
`java.sql.ResultSet` | `executeQuery(java.lang.String sql)` This method should always throw if called for a PreparedStatement or CallableStatment.
`int` | `executeUpdate()` Executes the SQL statement in this `PreparedStatement` object, which must be an SQL `INSERT`, `UPDATE` or `DELETE` statement; or an SQL statement that returns nothing, such as a DDL statement.
`int` | `executeUpdate(java.lang.String sql)` This method should always throw if called for a PreparedStatement or CallableStatment.
`java.sql.ResultSetMetaData` | `getMetaData()` Retrieves a `ResultSetMetaData` object that contains information about the columns of the `ResultSet` object that will be returned when this `PreparedStatement` object is executed.
`java.sql.ParameterMetaData` | `getParameterMetaData()` Retrieves the number, types and properties of this `PreparedStatement` object's parameters.
`void` | `setArray(int i, java.sql.Array x)` Sets the designated parameter to the given `Array` object.
`void` | `setAsciiStream(int parameterIndex, java.io.InputStream x, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` | `setBigDecimal(int parameterIndex, java.math.BigDecimal x)` Sets the designated parameter to the given `java.math.BigDecimal` value.
`void` | `setBinaryStream(int parameterIndex, java.io.InputStream x, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` | `setBlob(int i, java.sql.Blob x)` Sets the designated parameter to the given `Blob` object.
`void` | `setBoolean(int parameterIndex, boolean x)` Sets the designated parameter to the given Java `boolean` value.
`void` | `setByte(int parameterIndex, byte x)` Sets the designated parameter to the given Java `byte` value.
`void` | `setBytes(int paramIndex, byte[] x)` Sets the designated parameter to the given Java array of bytes.
`void` | `setCharacterStream(int parameterIndex, java.io.Reader reader, int length)` Sets the designated parameter to the given `Reader` object, which is the given number of characters long.
`void` | `setClob(int i, java.sql.Clob x)` Sets the designated parameter to the given `Clob` object.
`void` | `setDate(int parameterIndex, java.sql.Date x)` Sets the designated parameter to the given `java.sql.Date` value.
`void` | `setDate(int parameterIndex, java.sql.Date x, java.util.Calendar cal)` Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object.
`void` | `setDouble(int parameterIndex, double x)` Sets the designated parameter to the given Java `double` value.
`void` | `setEscapeProcessing(boolean enable)` Sets escape processing on or off.
`void` | `setFloat(int parameterIndex, float x)` Sets the designated parameter to the given Java `float` value.
`void` | `setInt(int parameterIndex, int x)` Sets the designated parameter to the given Java `int` value.
`void` | `setLong(int parameterIndex, long x)` Sets the designated parameter to the given Java `long` value.
`void` | `setNull(int paramIndex, int sqlType)` Sets the designated parameter to SQL `NULL`.
`void` | `setNull(int paramIndex, int sqlType, java.lang.String typeName)` Sets the designated parameter to SQL `NULL`.
`void` | `setObject(int parameterIndex, java.lang.Object x)` Sets the value of the designated parameter using the given object.
`void` | `setObject(int parameterIndex, java.lang.Object x, int targetSqlType)` Sets the value of the designated parameter with the given object.
`void` | `setObject(int parameterIndex, java.lang.Object x, int targetSqlType, int scale)` Sets the value of the designated parameter with the given object.
`void` | `setRef(int i, java.sql.Ref x)` Sets the designated parameter to the given `REF(<structured-type>)` value.
`void` | `setShort(int parameterIndex, short x)` Sets the designated parameter to the given Java `short` value.
`void` | `setString(int parameterIndex, java.lang.String x)` Sets the designated parameter to the given Java `String` value.
`void` | `setTime(int parameterIndex, java.sql.Time x)` Sets the designated parameter to the given `java.sql.Time` value.
`void` | `setTime(int parameterIndex, java.sql.Time x, java.util.Calendar cal)` Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object.
`void` | `setTimestamp(int parameterIndex, java.sql.Timestamp x)` Sets the designated parameter to the given `java.sql.Timestamp` value.
`void` | `setTimestamp(int parameterIndex, java.sql.Timestamp x, java.util.Calendar cal)` Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object.
`void` | `setUnicodeStream(int parameterIndex, java.io.InputStream x, int length)` Deprecated. Sun does not include a reason, but presumably this is because setCharacterStream is now prefered
`void` | `setURL(int parameterIndex, java.net.URL x)` Sets the designated parameter to the given `java.net.URL` value.
`java.lang.String` | `toString()` Retrieves a String representation of this object.

Methods inherited from class org.hsqldb.jdbc.jdbcStatement
`cancel, clearBatch, clearWarnings, execute, execute, execute, executeUpdate, executeUpdate, executeUpdate, getConnection, getFetchDirection, getFetchSize, getGeneratedKeys, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, isClosed, setCursorName, setFetchDirection, setFetchSize, setMaxFieldSize, setMaxRows, setQueryTimeout`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.sql.PreparedStatement
`setAsciiStream, setAsciiStream, setBinaryStream, setBinaryStream, setBlob, setBlob, setCharacterStream, setCharacterStream, setClob, setClob, setNCharacterStream, setNCharacterStream, setNClob, setNClob, setNClob, setNString, setRowId, setSQLXML`

Methods inherited from interface java.sql.Statement
`cancel, clearBatch, clearWarnings, execute, execute, execute, executeUpdate, executeUpdate, executeUpdate, getConnection, getFetchDirection, getFetchSize, getGeneratedKeys, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, isClosed, isPoolable, setCursorName, setFetchDirection, setFetchSize, setMaxFieldSize, setMaxRows, setPoolable, setQueryTimeout`

Methods inherited from interface java.sql.Wrapper
`isWrapperFor, unwrap`

Method Detail

### setEscapeProcessing

    public void setEscapeProcessing(boolean enable)
                             throws java.sql.SQLException

  Sets escape processing on or off.

  ### HSQLDB-Specific Information:

  Since 1.7.0, the implementation follows the standard behaviour by overriding the same method in jdbcStatement class.

  In other words, calling this method has no effect.

  Specified by:
    `setEscapeProcessing` in interface `java.sql.Statement`
  Overrides:
    `setEscapeProcessing` in class `jdbcStatement`
  Parameters:
    `enable` - `true` to enable escape processing; `false` to disable it
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### execute

    public boolean execute()
                    throws java.sql.SQLException

  Executes the SQL statement in this `PreparedStatement` object, which may be any kind of SQL statement. Some prepared statements return multiple results; the `execute` method handles these complex statements as well as the simpler form of statements handled by the methods `executeQuery`and `executeUpdate`.

  The `execute` method returns a `boolean` to indicate the form of the first result. You must call either the method `getResultSet` or `getUpdateCount` to retrieve the result; you must call `getMoreResults` to move to any subsequent result(s).

  ### HSQLDB-Specific Information:

  Including 1.8.0, prepared statements do not generate multiple fetchable results.

  In future versions, it will be possible that statements generate multiple fetchable results under certain conditions.

  Specified by:
    `execute` in interface `java.sql.PreparedStatement`
  Returns:
    `true` if the first result is a `ResultSet` object; `false` if the first result is an update count or there is no result
  Throws:
    `java.sql.SQLException` - if a database access error occurs or an argument is supplied to this method
  See Also:
    `jdbcStatement.execute(java.lang.String)`, `jdbcStatement.getResultSet()`, `jdbcStatement.getUpdateCount()`, `jdbcStatement.getMoreResults()`

### executeQuery

    public java.sql.ResultSet executeQuery()
                                    throws java.sql.SQLException

  Executes the SQL query in this `PreparedStatement` object and returns the `ResultSet` object generated by the query.

  Specified by:
    `executeQuery` in interface `java.sql.PreparedStatement`
  Returns:
    a `ResultSet` object that contains the data produced by the query; never `null`
  Throws:
    `java.sql.SQLException` - if a database access error occurs or the SQL statement does not return a `ResultSet` object

### executeUpdate

    public int executeUpdate()
                      throws java.sql.SQLException

  Executes the SQL statement in this `PreparedStatement` object, which must be an SQL `INSERT`, `UPDATE` or `DELETE` statement; or an SQL statement that returns nothing, such as a DDL statement.

  Specified by:
    `executeUpdate` in interface `java.sql.PreparedStatement`
  Returns:
    either (1) the row count for `INSERT`, `UPDATE`, or `DELETE` statements or (2) 0 for SQL statements that return nothing
  Throws:
    `java.sql.SQLException` - if a database access error occurs or the SQL statement returns a `ResultSet` object

### executeBatch

    public int[] executeBatch()
                       throws java.sql.SQLException

  Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts. The `int` elements of the array that is returned are ordered to correspond to the commands in the batch, which are ordered according to the order in which they were added to the batch. The elements in the array returned by the method `executeBatch` may be one of the following:
  1. A number greater than or equal to zero -- indicates that the command was processed successfully and is an update count giving the number of rows in the database that were affected by the command's execution
  2. A value of `SUCCESS_NO_INFO` -- indicates that the command was processed successfully but that the number of rows affected is unknown

     If one of the commands in a batch update fails to execute properly, this method throws a `BatchUpdateException`, and a JDBC driver may or may not continue to process the remaining commands in the batch. However, the driver's behavior must be consistent with a particular DBMS, either always continuing to process commands or never continuing to process commands. If the driver continues processing after a failure, the array returned by the method `BatchUpdateException.getUpdateCounts` will contain as many elements as there are commands in the batch, and at least one of the elements will be the following:

  3. A value of `EXECUTE_FAILED` -- indicates that the command failed to execute successfully and occurs only if a driver continues to process commands after a command fails

  A driver is not required to implement this method. The possible implementations and return values have been modified in the Java 2 SDK, Standard Edition, version 1.3 to accommodate the option of continuing to proccess commands in a batch update after a `BatchUpdateException` obejct has been thrown.

  ### HSQLDB-Specific Information:

  Starting with HSQLDB 1.7.2, this feature is supported.

  HSQLDB stops execution of commands in a batch when one of the commands results in an exception. The size of the returned array equals the number of commands that were executed successfully.

  When the product is built under the JAVA1 target, an exception is never thrown and it is the responsibility of the client software to check the size of the returned update count array to determine if any batch items failed. To build and run under the JAVA2 target, JDK/JRE 1.3 or higher must be used.

  Specified by:
    `executeBatch` in interface `java.sql.Statement`
  Overrides:
    `executeBatch` in class `jdbcStatement`
  Returns:
    an array of update counts containing one element for each command in the batch. The elements of the array are ordered according to the order in which commands were added to the batch.
  Throws:
    `java.sql.SQLException` - if a database access error occurs or the driver does not support batch statements. Throws `BatchUpdateException` (a subclass of `java.sql.SQLException`) if one of the commands sent to the database fails to execute properly or attempts to return a result set.
  Since:
    JDK 1.3 (JDK 1.1.x developers: read the new overview for jdbcStatement)

### setNull

    public void setNull(int paramIndex,
                        int sqlType)
                 throws java.sql.SQLException

  Sets the designated parameter to SQL `NULL`.

  Note: You must specify the parameter's SQL type.

  ### HSQLDB-Specific Information:

  HSQLDB ignores the sqlType argument.

  Specified by:
    `setNull` in interface `java.sql.PreparedStatement`
  Parameters:
    `paramIndex` - the first parameter is 1, the second is 2, ...
    `sqlType` - the SQL type code defined in `java.sql.Types`
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setBoolean

    public void setBoolean(int parameterIndex,
                           boolean x)
                    throws java.sql.SQLException

  Sets the designated parameter to the given Java `boolean` value. The driver converts this to an SQL `BIT` value when it sends it to the database.

  ### HSQLDB-Specific Information:

  Since 1.7.2, HSQLDB uses the BOOLEAN type instead of BIT, as per SQL 200n (SQL 3).

  Specified by:
    `setBoolean` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setByte

    public void setByte(int parameterIndex,
                        byte x)
                 throws java.sql.SQLException

  Sets the designated parameter to the given Java `byte` value. The driver converts this to an SQL `TINYINT` value when it sends it to the database.

  Specified by:
    `setByte` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setShort

    public void setShort(int parameterIndex,
                         short x)
                  throws java.sql.SQLException

  Sets the designated parameter to the given Java `short` value. The driver converts this to an SQL `SMALLINT` value when it sends it to the database.

  Specified by:
    `setShort` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setInt

    public void setInt(int parameterIndex,
                       int x)
                throws java.sql.SQLException

  Sets the designated parameter to the given Java `int` value. The driver converts this to an SQL `INTEGER` value when it sends it to the database.

  Specified by:
    `setInt` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setLong

    public void setLong(int parameterIndex,
                        long x)
                 throws java.sql.SQLException

  Sets the designated parameter to the given Java `long` value. The driver converts this to an SQL `BIGINT` value when it sends it to the database.

  Specified by:
    `setLong` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setFloat

    public void setFloat(int parameterIndex,
                         float x)
                  throws java.sql.SQLException

  Sets the designated parameter to the given Java `float` value. The driver converts this to an SQL `FLOAT` value when it sends it to the database.

  ### HSQLDB-Specific Information:

  Since 1.7.1, HSQLDB handles Java positive/negative Infinity and NaN `float` values consistent with the Java Language Specification; these special values are now correctly stored to and retrieved from the database.

  Specified by:
    `setFloat` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setDouble

    public void setDouble(int parameterIndex,
                          double x)
                   throws java.sql.SQLException

  Sets the designated parameter to the given Java `double` value. The driver converts this to an SQL `DOUBLE` value when it sends it to the database.

  ### HSQLDB-Specific Information:

  Since 1.7.1, HSQLDB handles Java positive/negative Infinity and NaN `double` values consistent with the Java Language Specification; these special values are now correctly stored to and retrieved from the database.

  Specified by:
    `setDouble` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setBigDecimal

    public void setBigDecimal(int parameterIndex,
                              java.math.BigDecimal x)
                       throws java.sql.SQLException

  Sets the designated parameter to the given `java.math.BigDecimal` value. The driver converts this to an SQL `NUMERIC` value when it sends it to the database.

  Specified by:
    `setBigDecimal` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setString

    public void setString(int parameterIndex,
                          java.lang.String x)
                   throws java.sql.SQLException

  Sets the designated parameter to the given Java `String` value. The driver converts this to an SQL `VARCHAR` or `LONGVARCHAR` value (depending on the argument's size relative to the driver's limits on `VARCHAR` values) when it sends it to the database.

  ### HSQLDB-Specific Information:

  Including 1.7.2, HSQLDB stores all XXXCHAR values as java.lang.String objects; there is no appreciable difference between CHAR, VARCHAR and LONGVARCHAR.

  Specified by:
    `setString` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setBytes

    public void setBytes(int paramIndex,
                         byte[] x)
                  throws java.sql.SQLException

  Sets the designated parameter to the given Java array of bytes. The driver converts this to an SQL `VARBINARY` or `LONGVARBINARY` (depending on the argument's size relative to the driver's limits on `VARBINARY` values) when it sends it to the database.

  ### HSQLDB-Specific Information:

  Including 1.7.2, HSQLDB stores all XXXBINARY values the same way; there is no appreciable difference between BINARY, VARBINARY and LONGVARBINARY.

  Specified by:
    `setBytes` in interface `java.sql.PreparedStatement`
  Parameters:
    `paramIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setDate

    public void setDate(int parameterIndex,
                        java.sql.Date x)
                 throws java.sql.SQLException

  Sets the designated parameter to the given `java.sql.Date` value. The driver converts this to an SQL `DATE` value when it sends it to the database.

  Specified by:
    `setDate` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setTime

    public void setTime(int parameterIndex,
                        java.sql.Time x)
                 throws java.sql.SQLException

  Sets the designated parameter to the given `java.sql.Time` value. The driver converts this to an SQL `TIME` value when it sends it to the database.

  Specified by:
    `setTime` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setTimestamp

    public void setTimestamp(int parameterIndex,
                             java.sql.Timestamp x)
                      throws java.sql.SQLException

  Sets the designated parameter to the given `java.sql.Timestamp` value. The driver converts this to an SQL `TIMESTAMP` value when it sends it to the database.

  Specified by:
    `setTimestamp` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setAsciiStream

    public void setAsciiStream(int parameterIndex,
                               java.io.InputStream x,
                               int length)
                        throws java.sql.SQLException

  Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  ### HSQLDB-Specific Information:

  This method uses the default platform character encoding to convert bytes from the stream into the characters of a String. In the future this is likely to change to always treat the stream as ASCII.

  Before HSQLDB 1.7.0, `setAsciiStream` and `setUnicodeStream` were identical.

  Specified by:
    `setAsciiStream` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the Java input stream that contains the ASCII parameter value
    `length` - the number of bytes in the stream
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setUnicodeStream

    public void setUnicodeStream(int parameterIndex,
                                 java.io.InputStream x,
                                 int length)
                          throws java.sql.SQLException

  Deprecated. Sun does not include a reason, but presumably this is because setCharacterStream is now prefered

  Sets the designated parameter to the given input stream, which will have the specified number of bytes. A Unicode character has two bytes, with the first byte being the high byte, and the second being the low byte. When a very large Unicode value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from Unicode to the database char format.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  ### HSQLDB-Specific Information:

  Since 1.7.0, this method complies with behavior as defined by the JDBC3 specification.

  Specified by:
    `setUnicodeStream` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - a `java.io.InputStream` object that contains the Unicode parameter value as two-byte Unicode characters
    `length` - the number of bytes in the stream
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setBinaryStream

    public void setBinaryStream(int parameterIndex,
                                java.io.InputStream x,
                                int length)
                         throws java.sql.SQLException

  Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  ### HSQLDB-Specific Information:

  Since 1.7.2, this method works according to the standard.

  Specified by:
    `setBinaryStream` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the java input stream which contains the binary parameter value
    `length` - the number of bytes in the stream
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### clearParameters

    public void clearParameters()
                         throws java.sql.SQLException

  Clears the current parameter values immediately.

  In general, parameter values remain in force for repeated use of a statement. Setting a parameter value automatically clears its previous value. However, in some cases it is useful to immediately release the resources used by the current parameter values; this can be done by calling the method `clearParameters`.

  Specified by:
    `clearParameters` in interface `java.sql.PreparedStatement`
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setObject

    public void setObject(int parameterIndex,
                          java.lang.Object x,
                          int targetSqlType,
                          int scale)
                   throws java.sql.SQLException

  Sets the value of the designated parameter with the given object.

  The second argument must be an object type; for integral values, the `java.lang` equivalent objects should be used.

  The given Java object will be converted to the given targetSqlType before being sent to the database. If the object has a custom mapping (is of a class implementing the interface `SQLData`), the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `Struct`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

  Note that this method may be used to pass database-specific abstract data types.

  ### HSQLDB-Specific Information:

  Inculding 1.7.1,this method was identical to `setObject(int, Object, int)`. That is, this method simply called setObject(int, Object, int), ignoring the scale specification.

  Since 1.7.2, this method supports the conversions listed in the conversion table B-5 of the JDBC 3 specification. The scale argument is not used.

  Specified by:
    `setObject` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the object containing the input parameter value
    `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database. The scale argument may further qualify this type.
    `scale` - for java.sql.Types.DECIMAL or java.sql.Types.NUMERIC types, this is the number of digits after the decimal point. For all other types, this value will be ignored.

    Up to and including HSQLDB 1.7.0, this parameter is ignored.

  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `Types`, `setObject(int,Object,int)`

### setObject

    public void setObject(int parameterIndex,
                          java.lang.Object x,
                          int targetSqlType)
                   throws java.sql.SQLException

  Sets the value of the designated parameter with the given object. This method is like the method `setObject` above, except that it assumes a scale of zero.

  ### HSQLDB-Specific Information:

  Since 1.7.2, this method supports conversions listed in the conversion table B-5 of the JDBC 3 specification.

  Specified by:
    `setObject` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the object containing the input parameter value
    `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `setObject(int,Object)`

### setObject

    public void setObject(int parameterIndex,
                          java.lang.Object x)
                   throws java.sql.SQLException

  Sets the value of the designated parameter using the given object.

  The second parameter must be of type `Object`; therefore, the `java.lang` equivalent objects should be used for built-in types.

  The JDBC specification specifies a standard mapping from Java `Object` types to SQL types. The given argument will be converted to the corresponding SQL type before being sent to the database.

  Note that this method may be used to pass datatabase- specific abstract data types, by using a driver-specific Java type. If the object is of a class implementing the interface `SQLData`, the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `Struct`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

  This method throws an exception if there is an ambiguity, for example, if the object is of a class implementing more than one of the interfaces named above.

  ### HSQLDB-Specific Information:

  Since 1.7.2, this method supports conversions listed in the conversion table B-5 of the JDBC 3 specification.

  Specified by:
    `setObject` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the object containing the input parameter value
  Throws:
    `java.sql.SQLException` - if a database access error occurs or the type of the given object is ambiguous

### addBatch

    public void addBatch()
                  throws java.sql.SQLException

  Adds a set of parameters to this `PreparedStatement` object's batch of commands.

  ### HSQLDB-Specific Information:

  Since 1.7.2, this feature is supported.

  Specified by:
    `addBatch` in interface `java.sql.PreparedStatement`
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcPreparedStatement)
  See Also:
    `jdbcStatement.addBatch(java.lang.String)`

### setCharacterStream

    public void setCharacterStream(int parameterIndex,
                                   java.io.Reader reader,
                                   int length)
                            throws java.sql.SQLException

  Sets the designated parameter to the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  ### HSQLDB-Specific Information:

  HSQLDB stores CHARACTER and related SQL types as Unicode so this method does not perform any conversion.

  Specified by:
    `setCharacterStream` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `reader` - the `java.io.Reader` object that contains the Unicode data
    `length` - the number of characters in the stream
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcPreparedStatement)

### setRef

    public void setRef(int i,
                       java.sql.Ref x)
                throws java.sql.SQLException

  Sets the designated parameter to the given `REF(<structured-type>)` value. The driver converts this to an SQL `REF` value when it sends it to the database.

  ### HSQLDB-Specific Information:

  HSQLDB 1.7.2 does not support the SQL REF type. Calling this method throws an exception.

  Specified by:
    `setRef` in interface `java.sql.PreparedStatement`
  Parameters:
    `i` - the first parameter is 1, the second is 2, ...
    `x` - an SQL `REF` value
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcPreparedStatement)

### setBlob

    public void setBlob(int i,
                        java.sql.Blob x)
                 throws java.sql.SQLException

  Sets the designated parameter to the given `Blob` object. The driver converts this to an SQL `BLOB` value when it sends it to the database.

  ### HSQLDB-Specific Information:

  Previous to 1.7.2, this feature was not supported.

  Since 1.7.2, setBlob is supported. With 1.7.2, setting Blob objects is limited to those of length less than or equal to Integer.MAX_VALUE. In 1.7.2, setBlob(i,x) is roughly equivalent (null and length handling not shown) to:

       setBinaryStream(i, x.getBinaryStream(), (int) x.length());

  Specified by:
    `setBlob` in interface `java.sql.PreparedStatement`
  Parameters:
    `i` - the first parameter is 1, the second is 2, ...
    `x` - a `Blob` object that maps an SQL `BLOB` value
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcPreparedStatement)

### setClob

    public void setClob(int i,
                        java.sql.Clob x)
                 throws java.sql.SQLException

  Sets the designated parameter to the given `Clob` object. The driver converts this to an SQL `CLOB` value when it sends it to the database.

  ### HSQLDB-Specific Information:

  Previous to 1.7.2, this feature was not supported.

  Since 1.7.2, setClob is supported. With 1.7.2, setting Blob objects is limited to those of length less than or equal to Integer.MAX_VALUE. In 1.7.2, setClob(i,x) is rougly equivalent (null and length handling not shown) to:

       setCharacterStream(i, x.getCharacterStream(), (int) x.length());

  Specified by:
    `setClob` in interface `java.sql.PreparedStatement`
  Parameters:
    `i` - the first parameter is 1, the second is 2, ...
    `x` - a `Clob` object that maps an SQL `CLOB` value
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcPreparedStatement)

### setArray

    public void setArray(int i,
                         java.sql.Array x)
                  throws java.sql.SQLException

  Sets the designated parameter to the given `Array` object. The driver converts this to an SQL `ARRAY` value when it sends it to the database.

  ### HSQLDB-Specific Information:

  HSQLDB 1.7.2 does not support the SQL ARRAY type. Calling this method throws an exception.

  Specified by:
    `setArray` in interface `java.sql.PreparedStatement`
  Parameters:
    `i` - the first parameter is 1, the second is 2, ...
    `x` - an `Array` object that maps an SQL `ARRAY` value
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcPreparedStatement)

### getMetaData

    public java.sql.ResultSetMetaData getMetaData()
                                           throws java.sql.SQLException

  Retrieves a `ResultSetMetaData` object that contains information about the columns of the `ResultSet` object that will be returned when this `PreparedStatement` object is executed.

  Because a `PreparedStatement` object is precompiled, it is possible to know about the `ResultSet` object that it will return without having to execute it. Consequently, it is possible to invoke the method `getMetaData` on a `PreparedStatement` object rather than waiting to execute it and then invoking the `ResultSet.getMetaData` method on the `ResultSet` object that is returned.

  NOTE: Using this method may be expensive for some drivers due to the lack of underlying DBMS support.

  ### HSQLDB-Specific Information:

  Since 1.7.2, this feature is supported. If the statement generates an update count, then null is returned.

  Specified by:
    `getMetaData` in interface `java.sql.PreparedStatement`
  Returns:
    the description of a `ResultSet` object's columns or `null` if the driver cannot return a `ResultSetMetaData` object
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcPreparedStatement)

### setDate

    public void setDate(int parameterIndex,
                        java.sql.Date x,
                        java.util.Calendar cal)
                 throws java.sql.SQLException

  Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `DATE` value,which the driver then sends to the database. With a a `Calendar` object, the driver can calculate the date taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

  Specified by:
    `setDate` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
    `cal` - the `Calendar` object the driver will use to construct the date
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcPreparedStatement)

### setTime

    public void setTime(int parameterIndex,
                        java.sql.Time x,
                        java.util.Calendar cal)
                 throws java.sql.SQLException

  Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIME` value, which the driver then sends to the database. With a a `Calendar` object, the driver can calculate the time taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

  Specified by:
    `setTime` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
    `cal` - the `Calendar` object the driver will use to construct the time
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcPreparedStatement)

### setTimestamp

    public void setTimestamp(int parameterIndex,
                             java.sql.Timestamp x,
                             java.util.Calendar cal)
                      throws java.sql.SQLException

  Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIMESTAMP` value, which the driver then sends to the database. With a `Calendar` object, the driver can calculate the timestamp taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

  Specified by:
    `setTimestamp` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
    `cal` - the `Calendar` object the driver will use to construct the timestamp
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcPreparedStatement)

### setNull

    public void setNull(int paramIndex,
                        int sqlType,
                        java.lang.String typeName)
                 throws java.sql.SQLException

  Sets the designated parameter to SQL `NULL`. This version of the method `setNull` should be used for user-defined types and REF type parameters. Examples of user-defined types include: STRUCT, DISTINCT, JAVA_OBJECT, and named array types.

  Note: To be portable, applications must give the SQL type code and the fully-qualified SQL type name when specifying a NULL user-defined or REF parameter. In the case of a user-defined type the name is the type name of the parameter itself. For a REF parameter, the name is the type name of the referenced type. If a JDBC driver does not need the type code or type name information, it may ignore it. Although it is intended for user-defined and Ref parameters, this method may be used to set a null parameter of any JDBC type. If the parameter does not have a user-defined or REF type, the given typeName is ignored.

  ### HSQLDB-Specific Information:

  HSQLDB ignores the sqlType and typeName arguments.

  Specified by:
    `setNull` in interface `java.sql.PreparedStatement`
  Parameters:
    `paramIndex` - the first parameter is 1, the second is 2, ...
    `sqlType` - a value from `java.sql.Types`
    `typeName` - the fully-qualified name of an SQL user-defined type; ignored if the parameter is not a user-defined type or REF
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the new overview for jdbcPreparedStatement)

### setURL

    public void setURL(int parameterIndex,
                       java.net.URL x)
                throws java.sql.SQLException

  Sets the designated parameter to the given `java.net.URL` value. The driver converts this to an SQL `DATALINK` value when it sends it to the database.

  ### HSQLDB-Specific Information:

  HSQLDB 1.7.2 does not support the DATALINK SQL type for which this method is intended. Calling this method throws an exception.

  Specified by:
    `setURL` in interface `java.sql.PreparedStatement`
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the `java.net.URL` object to be set
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQL 1.7.0

### getParameterMetaData

    public java.sql.ParameterMetaData getParameterMetaData()
                                                    throws java.sql.SQLException

  Retrieves the number, types and properties of this `PreparedStatement` object's parameters.

  ### HSQLDB-Specific Information:

  Since 1.7.2, this feature is supported.

  Specified by:
    `getParameterMetaData` in interface `java.sql.PreparedStatement`
  Returns:
    a `ParameterMetaData` object that contains information about the number, types and properties of this `PreparedStatement` object's parameters
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQL 1.7.0
  See Also:
    `ParameterMetaData`

### addBatch

    public void addBatch(java.lang.String sql)
                  throws java.sql.SQLException

  This method should always throw if called for a PreparedStatement or CallableStatment.

  Specified by:
    `addBatch` in interface `java.sql.Statement`
  Overrides:
    `addBatch` in class `jdbcStatement`
  Parameters:
    `sql` - ignored
  Throws:
    `java.sql.SQLException` - always
  See Also:
    `jdbcStatement.executeBatch()`

### executeQuery

    public java.sql.ResultSet executeQuery(java.lang.String sql)
                                    throws java.sql.SQLException

  This method should always throw if called for a PreparedStatement or CallableStatment.

  Specified by:
    `executeQuery` in interface `java.sql.Statement`
  Overrides:
    `executeQuery` in class `jdbcStatement`
  Parameters:
    `sql` - ignored
  Returns:
    nothing
  Throws:
    `java.sql.SQLException` - always

### execute

    public boolean execute(java.lang.String sql)
                    throws java.sql.SQLException

  This method should always throw if called for a PreparedStatement or CallableStatment.

  Specified by:
    `execute` in interface `java.sql.Statement`
  Overrides:
    `execute` in class `jdbcStatement`
  Parameters:
    `sql` - ignored
  Returns:
    nothing
  Throws:
    `java.sql.SQLException` - always
  See Also:
    `jdbcStatement.getResultSet()`, `jdbcStatement.getUpdateCount()`, `jdbcStatement.getMoreResults()`

### executeUpdate

    public int executeUpdate(java.lang.String sql)
                      throws java.sql.SQLException

  This method should always throw if called for a PreparedStatement or CallableStatment.

  Specified by:
    `executeUpdate` in interface `java.sql.Statement`
  Overrides:
    `executeUpdate` in class `jdbcStatement`
  Parameters:
    `sql` - ignored
  Returns:
    nothing
  Throws:
    `java.sql.SQLException` - always

### close

    public void close()
               throws java.sql.SQLException

  Does the specialized work required to free this object's resources and that of it's parent class.

  Specified by:
    `close` in interface `java.sql.Statement`
  Overrides:
    `close` in class `jdbcStatement`
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### toString

    public java.lang.String toString()

  Retrieves a String representation of this object.

  The representation is of the form:

  class-name@hash[sql=[char-sequence], parameters=[p1, ...pi, ...pn]]

  p1, ...pi, ...pn are the String representations of the currently set parameter values that will be used with the non-batch execution methods.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    a String representation of this object

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001 - 2005 HSQL Development Group. All Rights Reserved.